classif <- system("grep -E '/[12].[0-9]|\\SYN {' buxineae_classif.tex", intern=T)

GENUS <- ifelse(grepl("2\\.0", classif), gsub("[^ ]* ([^ ]*) .*$", "\\1", classif), "")
SUBGENUS <- ifelse(grepl("1\\.8", classif), gsub("[^ ]* ([^ \\]*).*$", "\\1", classif), "")
SUBGENUS <- paste0(GENUS, SUBGENUS)
SPECIES <- ifelse(grepl("1\\.0", classif), gsub(".*\\{(.*)\\}.*$", "\\1", classif), "")
SPECIES[SUBGENUS != ""] <- NA
SYNONYMS <- ifelse(grepl("\\SYN", classif), gsub(".*\\{([^}]*)\\}.*$", "\\1", classif), NA)

sp <- data.frame(GENUS, SUBGENUS, SPECIES, SYNONYMS, stringsAsFactors=F)

for(a in 1:3) {
 while(length(ind <- which(sp[[a]] == "")) > 0) sp[[a]][ind] <- sp[[a]][ind-1]
}

sp <- sp[!is.na(sp$SPECIES), ]

treesp <- read.table("../../data/buxineae_treesp.txt", sep="\t", h=T, as.is=T)
outgroup <- treesp["SPECIES.NEW"][treesp$TYPE == "outgroup", , drop=F]
names(outgroup) <- "SPECIES"
outgroup$GENUS <- do.call(rbind, strsplit(outgroup$SPECIES, split=" "))[, 1]
outgroup$SUBGENUS <- outgroup$GENUS # not exacly correct but used in labelins so leave it
outgroup$SYNONYMS <- NA

sp <- rbind(sp, outgroup)

write.table(sp, file="../../data/buxineae_sp.txt", row.names=F, quote=F, sep="\t")
