library(shipunov)

aa <- read.table("../../data/buxineae_dna.txt", sep="\t", h=T, as.is=T, quote="")
aa <- aa[order(aa$FRAGMENT, aa$SPECIES.NEW), ]

aa <- aa[aa$SELECT == 1 | is.na(aa$SELECT), ]

aas <- split(aa[, c("SOURCE", "SPECIES.NEW", "SEQUENCE.ID", "SEQUENCE")], aa$FRAGMENT)

for (s in names(aas)) {
 subs <- aas[[s]]
 subs.misu <- subs[subs$SOURCE != "GENBANK", ] # keep ours
 subs.misu.sp <- unique(sort(subs.misu$SPECIES.NEW))
 subs.genbank <- subs[subs$SOURCE == "GENBANK", ]
 subs.genbank <- subs.genbank[!subs.genbank$SPECIES %in% subs.misu.sp, ] # remove species which we already have
 subs.genbank <- subs.genbank[order(subs.genbank$SPECIES.NEW, nchar(subs.genbank$SEQUENCE), decreasing=T), ] # sort by length, longer first
 subs.genbank <- subs.genbank[!duplicated(subs.genbank$SPECIES), ] # take the first
 subs <- rbind(subs.misu, subs.genbank) # join back
 subs$ID <- apply(subs[, c("SPECIES.NEW", "SEQUENCE.ID")], 1, function(.x) paste0(.x, collapse="__")) # separator is "__", the rest unchanged
 subs[, c("SOURCE", "SPECIES.NEW", "SEQUENCE.ID")] <- NULL # remove columns except 2
 subs <- subs[, 2:1] # ID first
 Write.fasta(subs, file=paste0("20_sets/", s, ".fasta"))
}
