options(stringsAsFactors=FALSE)
library(shipunov)

its <- read.table("../../data/ext/genbank/current/its_tab.txt", sep="\t", h=TRUE, as.is=TRUE)
matk <- read.table("../../data/ext/genbank/current/matk_tab.txt", sep="\t", h=TRUE, as.is=TRUE)
petd <- read.table("../../data/ext/genbank/current/petd_tab.txt", sep="\t", h=TRUE, as.is=TRUE)
rbcl <- read.table("../../data/ext/genbank/current/rbcl_tab.txt", sep="\t", h=TRUE, as.is=TRUE)
trnl <- read.table("../../data/ext/genbank/current/trnl_tab.txt", sep="\t", h=TRUE, as.is=TRUE)

genbank <- rbind(data.frame(its, FRAGMENT="its"), data.frame(matk, FRAGMENT="matk"), data.frame(petd, FRAGMENT="petd"), data.frame(rbcl, FRAGMENT="rbcl"), data.frame(trnl, FRAGMENT="trnl"))

dna <- read.table("../../data/buxineae_dna.txt", sep="\t", h=TRUE, as.is=TRUE, quote="")
sp <- read.table("../../data/buxineae_sp.txt", sep="\t", h=TRUE, as.is=TRUE)

genbank$SPECIES[!genbank$SPECIES %in% sp$SPECIES] <- Recode(genbank$SPECIES[!genbank$SPECIES %in% sp$SPECIES], sp$SYNONYMS, sp$SPECIES)

cat("Not in buxineae_sp:\n", paste0(genbank$SPECIES[!genbank$SPECIES %in% sp$SPECIES], "\n"))
genbank <- genbank[genbank$SPECIES %in% sp$SPECIES, ]
genbank$SOURCE <- "GENBANK"
names(genbank)[names(genbank) == "ID"] <- "SEQUENCE.ID.ORIG"
names(genbank)[names(genbank) == "SPECIES"] <- "SPECIES.NEW"
genbank$SEQUENCE.ID <- NA
genbank$SELECT <- NA
genbank$COMMENT <- NA

genbank <- genbank[!genbank$SEQUENCE.ID.ORIG %in% dna$SEQUENCE.ID.ORIG, ]

dna <- rbind(dna, genbank)
# rename manually if OK
write.table(dna, file="../../data/buxineae_dna_new.txt", sep="\t", quote=FALSE, row.names=FALSE)
